(* simple lexer for regular expressions *)

{
open Parse
}

let ws = [' ' '\t']

rule lexer = parse
  ws+   { lexer lexbuf }
| '\n'  { LNewline }
| '('   { LLParen }
| ')'   { LRParen }
| '*'   { LStar }
| '|'   { LOr }
| '"'   { LQuote }
| ['a'-'z''A'-'Z']+ { LString (Lexing.lexeme lexbuf) }
| eof { LEof }
