%{
open Ast

let string_to_sequence s =
  let len = String.length s in
  let get = String.get s in
  let rec loop i =
    if i = len - 1
    then Char(get i)
    else Sequence(Char(get i), loop (i+1)) in
  loop 0
%}

%start program

%type <Ast.regexp * string> program
%type <Ast.regexp> regexp
%type <string>  str

%token LLParen LRParen LNewline LStar LOr LQuote
%token LEof
%token <string> LString

%%

str:
  LQuote LString LQuote { $2 }

regexp:
  LString { string_to_sequence $1 }
| LLParen regexp LRParen LLParen regexp LRParen { Sequence($2,$5) }
| LLParen regexp LRParen LOr LLParen regexp LRParen { Alternative($2,$6) }
| LLParen regexp LRParen LStar { Star($2) }
| LLParen regexp LRParen { $2 }

program:
  regexp LNewline str nl LEof { ($1,$3) }  
| regexp LNewline str LEof { ($1,$3) }  

nl:
  LNewline {()}
| LNewline nl {()}

%%
